#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"

struct PDF_Trailer *read_trailer(int );
char *find_trailer(int , long );
BOOLEAN Load_pdf_info(char *, struct PDF_Info *);
void Show_pdf_info(struct PDF_Info *);


/*
	The list line should only looks like this:
	"%%EOF"
	So the line length is 5.
*/

BOOLEAN Check_last_line(struct PDF_Info *PDF_Info)
	{
	unsigned long size=0, size2 = PDF_Info->file_info->buff_size;
	char output[10]={0};

	if(PDF_Info->file_info->handle || PDF_Info->file_info->buffer)
		{
		if(PDF_Info->file_info->buffer!=NULL)			/* Is the file opened and loaded?		*/
			{
			while(size==0)
				{
				if(PDF_Info->file_info->buffer[size2]!=0x00 && PDF_Info->file_info->buffer[size2]!='\r' && PDF_Info->file_info->buffer[size2]!='\n')			/* Found line longer then 1?		*/
					size++;
				else
					size2--;
				}

			while(PDF_Info->file_info->buffer[size2]!='\n' && PDF_Info->file_info->buffer[size2]!='\r')			/* Go to the beginning of that line	*/
				size2--;

			size2++;

			strncpy(&output[0], &PDF_Info->file_info->buffer[size2], 5);	/* Copy the last line to the output variable	*/
			PDF_Info->file_info->actual_pos = size2 + size;						/* Change the position in the file						*/
			}
		else							/* The file is too big to load it into memory, so we have to operate on a file	*/
			{
			Fseek(size2-3, PDF_Info->file_info->handle, 0);
			while(output[0]!='\r' && output[0]!='\n')
				{
				size += read(PDF_Info->file_info->handle, &output[0], 1);
				Fseek(-2, PDF_Info->file_info->handle, 1);
				}
			Fseek(2, PDF_Info->file_info->handle, 1);
			read(PDF_Info->file_info->handle, &output[0], strlen("%%EOF"));
			PDF_Info->file_info->actual_pos = Fseek(0, PDF_Info->file_info->handle, 1) - strlen("%%EOF ");
			}
		}

	if(strncmp(output, "%%EOF", 5)==0)
		return(TRUE);
	else
		return(FALSE);
	}