
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<x_gem.h>
#include	<ctype.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"


char *Read_prev_line(struct files_pdf *file)
	{
	unsigned long pos, size=1;
	char character=0;
	char *output=NULL;

	if(file->buffer && file->handle<0)			/* Is the file loaded to memory?	*/
		{
		pos = file->actual_pos-1;
		if(file->buffer[pos]=='\r' || file->buffer[pos]=='\n')
			pos--;
		if(file->buffer[pos]=='\r' || file->buffer[pos]=='\n')
			pos--;

		while(file->buffer[pos]!='\r' && file->buffer[pos]!='\n')		/* Go to the end of previous line	*/
			pos--;

		if(file->buffer[pos]=='\r' || file->buffer[pos]=='\n')
			pos-=2;

		while(file->buffer[pos]!='\r' && file->buffer[pos]!='\n')		/* Go to the beginning of the previous line	*/
			pos--;

		pos++;
		while(file->buffer[pos]!='\n' && file->buffer[pos]!='\r')		/* Count how many chars are in the line			*/
			{
			size++;
			pos++;
			}

		output = calloc (1, size + 1);

		strncpy(output, &(file->buffer[pos+1-size]), size-1);
		}
	else									/* We have to operate on a file		*/
		{
		Fseek(file->actual_pos-1, file->handle, 0);
		read(file->handle, &character, 1);

		if(character=='\r' || character=='\n')
			Fseek(-2, file->handle, 1);
		if(character=='\r' || character=='\n')
			Fseek(-2, file->handle, 1);

		while(character!='\r' && character!='\n')		/* Go to the end of previous line	*/
			{
			Fseek(-2, file->handle, 1);
			read(file->handle, &character, 1);
			}

		read(file->handle, &character, 1);
		if(character=='\r' || character=='\n')
			Fseek(-2, file->handle, 1);

		while(character!='\r' && character!='\n')		/* Go to the beginning of the previous line	*/
			{
			read(file->handle, &character, 1);
			Fseek(-2, file->handle, 1);
			}
		pos = Fseek(2, file->handle, 1);
		character=0;

		while(character!='\n' && character!='\r')		/* Count how many chars are in the line			*/
			{
			read(file->handle, &character, 1);
			size++;
			}

		output = calloc (1, size + 1);
		Fseek(pos, file->handle, 0);

		read(file->handle, output, size-1);
		}

	return(output);
	}




char *Read_line(struct files_pdf *file)
{
	char j=0;
	char *buffer = NULL;
	static char *line;
	unsigned long size=0, size1=0;

	if(line)
		{
		free(line);
		line = NULL;
		}
	if(file==NULL)
		return(NULL);

	if(file->buffer && file->actual_pos<file->buff_size)		/* Let's operate on a buffer in memory	*/
		{
		buffer = &file->buffer[file->actual_pos];

		if(buffer)
		{
			if((file->actual_pos-file->buff_size)>10001)
			{
				j=buffer[10000];		/* Because of the speed reasons if a file is very big	*/
				buffer[10000]=0;
			}

			size1 = (unsigned long)strstr(buffer, "\n") - (unsigned long)buffer;
			size = (unsigned long)strstr(buffer, "\r") - (unsigned long)buffer;

			if ((file->actual_pos-file->buff_size)>10001)
			{
				buffer[10000] = j;
			}

			if(size1<size)			/* only "\n"?		*/
				size=size1;

			line = calloc (1, size + 16);
			if(line!=NULL)
				strncpy(line, buffer, size);
	
			if(file->buffer[file->actual_pos+size]=='\r')
				size++;
			if(file->buffer[file->actual_pos+size]=='\n')
				size++;

			file->actual_pos+=size;
			}
		}
	else						/* Let's operate on a file */
		{
		Fseek(file->actual_pos, file->handle, 0);
		buffer = calloc(1, 10001);
		if((file->actual_pos-file->buff_size)>10001)
		{
			read(file->handle, buffer, 10000);
			j=buffer[10000];		/* Because of the speed reasons if a file is very big	*/
			buffer[10000]=0;
		}

		size1 = (unsigned long)strstr(buffer, "\n") - (unsigned long)buffer;
		size = (unsigned long)strstr(buffer, "\r") - (unsigned long)buffer;

		if ((file->actual_pos-file->buff_size)>10001)
		{
			buffer[10000] = j;
		}

		if(size1<size)			/* only "\n"?		*/
			size=size1;

		if(size>0)
			{
			line = calloc (1, size + 16);
			strncpy(line, buffer, size);

			if(buffer[size]=='\r')
				size++;
			if(buffer[size]=='\n')
				size++;
			}

		file->actual_pos+=size;
		free(buffer);
		}
	return(line);
}
