#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"cont_pat.h"
#include	"windinfo.h"
#include	"page_con.h"
#include	"filters.h"


void Free_last_10_files(void);
void add_file_to_list(char *name);
void *Free_and_alloc(void *block, unsigned long size);

void Check_annotations(int event);
BOOLEAN Check_bubble(int event);
void Check_pictures(int event);
void Save_picture(char *name1, char *data, unsigned long length);


BOOLEAN Change_document_info(WIND_INFO *wind_info);

void Init_display_page (short window, struct PDF_Info *pdf_info);
void Display_page (WIND_LIST *wind);
double Change_scale(short window, struct PDF_Info *pdf_info, unsigned long *page_w, unsigned long *page_h, unsigned long *offset_x, unsigned long *offset_y,
										int *win_x, int *win_y, int *win_w, int *win_h, WIND_LIST *);
void clear_all_pdf_objects (WIND_LIST *wind);

char *PageNumber(struct PDF_Info *info, int page_no, char *string);

void Get_GoToPage(struct PDF_Info *info);
int Find_Page_Number_by_Outline(struct PDF_Info *pdf_info, struct PDF_Outline_dictionary *outline);

extern struct PDF_PageTree *find_page_tree(struct PDF_Info *info, struct PDF_PageTree *page, int page_no, int max);

struct PDF_Trailer *read_trailer(int );
char *find_trailer(int , long );
BOOLEAN Load_pdf_info (struct PDF_Info *);
void Show_pdf_info(struct PDF_Info *);
BOOLEAN Check_if_pdf(char *, struct PDF_Info *);
struct PDF_Info *Add_PDF_Info(void);
void FreePDF (struct PDF_Info *pdf_info);

BOOLEAN add2history;		/* We have to know if the new contents has to be added to the history or not. When we use
														the history buttons (REAR_TB, FORWARD_TB) then we do NOT add anything to the history.
														In other cases (normal document handling) we do that !!		*/

void init_mouse_pointer (void);
void Change_pointer(int no);

struct PDF_Outline_dictionary *Find_outline_no(struct PDF_Outline_dictionary *, int , int );
struct PDF_Outline_dictionary *read_outline_dict(struct PDF_Info *, int , int );
int find_page_no_by_contents(struct PDF_Info *info, size_t Contents);

void Display_thumbnails(WIND_INFO *, short , short , short , short );



#define UBYTE   unsigned char                 /* Unsigned byte               */
#define ULONG		unsigned long

ULONG	DHST_write( ULONG , ULONG , UBYTE *, UBYTE *, UBYTE *, UBYTE *);
ULONG	DHST_init( ULONG );

char *Read_text(struct files_pdf *);

void Save_PDF(int);

void Load_options(void);
void Save_options(BOOLEAN );
void handle_options_dialog(void);

extern struct opt options;
extern int wind_options_handle;		/* handle of the options window	*/
void handle_options_window(int);
void open_options_dialog(void);

extern int window_page_info_handle;
void open_page_info(void);
void handle_page_info(int, int);
void close_page_info(int);
void redraw_page_info_icon(int);
void update_page_info(void);
void redraw_icon_form (short );

extern struct file_position *root_position;
extern struct PDF_Info *root_pdf_info;
struct PDF_Info *root_pdf_info_find;


void Init_AV_Protocol(void);
void Exit_AV_Protocol(void);
int Send_AV(int , int , char *, char *);


void init_gem (void);
void exit_gem (void);
int gere_fenetres (void);
void gere_messages (void);
void gere_menu (void);
void gere_popup(short window);
void gere_keyboard(void);
short open_pdf_window (char *name);
void adapt_pdf_window (short window);
void redraw_pdf_window (short window);
void close_pdf_window (short window);
void update_pdf_window (short window);
int cdecl display_outline (PARMBLK *para);
short get_outline_number (short n, struct PDF_Outline_dictionary *out_obj);
void add_file_to_list(char *name);

short quit = 0;
short dialog_language;
short opened_pdf = 0;
short wh_status = -1;
OBJECT *adr_menu, *adr_toolbar, *adr_doc_info, *adr_page_info, *adr_steps, *adr_strings, *adr_popup_menu, *adr_popup_history, *adr_popup_thread, *adr_popup_zoom;
OBJECT *adr_popup_outline, *adr_last_files, *adr_gotopage, *adr_disp_tree;
OBJECT *adr_options, *adr_popup_lang, *adr_popup_work, *adr_popup_date, *adr_popup_units, *adr_popup_page_info, *adr_popup_windows, *adr_popup_dither, *adr_popup_over_picture;
OBJECT *adr_icons;
OBJECT *secret_change_info;

X_GEM_INFO *x_gem;
#define WINDS	16
WIND_LIST windows[WINDS];

short show_outline (WIND_INFO *wind_info, short posx, short posy, short miny, short maxy, struct PDF_Outline_dictionary *out_obj, struct PDF_Info *);


struct windows_popup
	{
	short handle;
	char name[20];
	BOOLEAN empty;
	}windows_popup[20];

void Take_to_top(int );
void Delete_window_from_popup(int );


/* ****************************************************************
		main(
 ****************************************************************** */

short main (int argc, char **argv)
{
	short event;

	#ifdef MEMDEBUG
		char *f_Erre = "MEM_ERR.DAT";
		char *f_Stat = "MEM_OUT.DAT";

		#define LONG_MAX	1048576L*64L	/* 64 MB max */

		Fdelete (f_Erre);
		Fdelete (f_Stat);

		set_MemdebugOptions (c_Yes, c_Yes, c_Yes, c_No, c_Yes, c_Yes, c_Yes, 0, LONG_MAX, f_Stat, f_Erre);
	#endif

	init_gem ();
	Load_options ();
	Init_AV_Protocol();

/*	convert_encoding();	*/

	vq_key_s (x_gem->handle, &event);
	if (event & K_LSHIFT || event & K_RSHIFT)
		options.step_by_step = TRUE;
	else
		options.step_by_step = FALSE;

	add2history = TRUE;

	if(argc>1)
	{
		if (open_pdf_window (argv[1]) == TRUE)
			add_file_to_list (argv[1]);
	}

	do													/* gem loop for events */
	{
		event = x_form_do (0L);							/* let Xgem works... */

		if(x_timers_event(3,100))			/* Every 0.5s	*/
			{
			Check_annotations(event);
			Check_pictures(event);
			x_timers_init (3);
			}

		if(options.bubble_time>0 && options.bubble_help==TRUE)
			{
			if(x_timers_event(4, options.bubble_time/5))			/* The checking time depends on the set time	*/
				Check_bubble(event);
			}
			

		if (event & MU_BUTTON)			/* Left mouse button	*/
			{
			if(gere_fenetres ()!=TRUE)
				Check_annotations(event);
			}

		if (event&MU_MESAG)
			gere_messages ();

		if(event&MU_KEYBD)
			gere_keyboard();

	} while (! quit);

	Save_options (TRUE);
	Exit_AV_Protocol();

	exit_gem ();

	return (0);
}


	/* initialising Gem and other stuffs... */
void init_gem (void)
{
	int i=0;

	x_gem = x_gem_init ("  MyPDF", windows, WINDS);
	if (! x_gem)										/* there is something wrong... ;) */
		exit (-1);

	Pdomain(1);
	x_rsrc_init (rs_trindex, rs_object, NUM_TREE, NUM_OBS, NUM_CIB);	/* rsc init */

	dialog_language = 0;								/* unused actually */

	adr_menu = TREE (E_MENU);
	adr_toolbar = rs_trindex[BIG_TOOLBAR];
	adr_doc_info = TREE (E_DOC_INFO);
	adr_page_info = TREE (PAGE_INFO);
	adr_steps = rs_trindex[FIRST_STEPS];
	adr_strings = TREE (E_STRINGS);

	adr_disp_tree = rs_trindex[DISP_TREE];

	adr_gotopage = rs_trindex[GOTOPAGE];

	adr_popup_menu = rs_trindex[POPUP_MENU];
	adr_popup_history = rs_trindex[POPUP_HISTORY];
	adr_popup_zoom = rs_trindex[E_POP_TOOLS];
	adr_popup_outline = rs_trindex[POPUP_OUTLINE];
	adr_popup_thread = rs_trindex[POPUP_THREADS];

	adr_options = rs_trindex[OPTIONS_DIALOG];
	adr_popup_lang = rs_trindex[POPUP_LANGUAGE];
	adr_popup_work = rs_trindex[POPUP_WORK_MODE];
	adr_popup_date = rs_trindex[POPUP_DATE];
	adr_popup_units = rs_trindex[POPUP_UNITS];
	adr_popup_page_info = rs_trindex[POPUP_PAGE_INFO];
	adr_popup_windows = rs_trindex[POPUP_WINDOW];
	adr_popup_dither = rs_trindex[POPUP_DITHERING];
	adr_popup_over_picture = rs_trindex[POPUP_IMAGE];
	adr_last_files = rs_trindex[POPUP_LAST_FILES];

	secret_change_info = rs_trindex[E_CHANGE_INFO];

	adr_icons = rs_trindex[ICON];

	adr_popup_menu[POPUP_M_OUTLINE].ob_state |= DISABLED;
	adr_popup_menu[POPUP_M_THREADS].ob_state |= DISABLED;

	x_set_menu_hierarch (adr_popup_menu, POPUP_M_ZOOM, E_POP_TOOLS);
	x_set_menu_hierarch (adr_popup_menu, POPUP_M_HISTORY, POPUP_HISTORY);
	x_set_menu_hierarch (adr_popup_menu, POPUP_M_WINDOW, POPUP_WINDOW);
	x_set_menu_hierarch (adr_menu, M_LAST_FILES, POPUP_LAST_FILES);
	x_set_menu_hierarch (adr_menu, M_WINDOWS, POPUP_WINDOW);

	if (x_gem->work_out[13] < 16)
		{
		adr_toolbar[PBAR_TB].ob_spec.obspec.interiorcol = BLACK;
		adr_toolbar[PBAR_TB].ob_spec.obspec.fillpattern = 4;
		adr_toolbar[PBAR_TB2].ob_spec.obspec.interiorcol = BLACK;
		adr_toolbar[PBAR_TB2].ob_spec.obspec.fillpattern = 7;

		adr_steps[STEPS_BAR_MAIN].ob_spec.obspec.interiorcol = WHITE;
		adr_steps[STEPS_BAR_MAIN].ob_spec.obspec.fillpattern = 7;
		}

	for(i=M_UNDO; i<(M_HELP_TOPIC+1); i++)
		menu_ienable( adr_menu, i, 0);

	for(i=0; i<20; i++)
		windows_popup[i].empty = TRUE;

	menu_ienable(adr_menu, M_OPTIONS, 1);
	menu_ienable(adr_menu, M_SAVE_OPTIONS, 1);
	menu_ienable(adr_menu, M_LOAD_OPTIONS, 1);

	menu_ienable(adr_menu, M_SECRET, 1);


	x_open_menu (adr_menu);							/* open the gem menu 			*/

	init_mouse_pointer ();							/* initialize animated mouse */
	x_timers_init (0);									/* for mouse 							*/
	x_timers_init (1);									/* for progres bar #1			*/
	x_timers_init (2);									/* for progres bar #2			*/
	x_timers_init (3);									/* for link annotations		*/
	x_timers_init (4);									/* for BubbleHelp					*/

	graf_mouse (ARROW, 0L);
}


void exit_gem (void)
{
	Free_last_10_files();

	Free_and_alloc(options.paths.default_pdf_dir, 0);
	
	x_close_all_winds ();
	x_close_menu (adr_menu);							/* wipe out the menu */

	x_rsrc_free (NUM_TREE, NUM_CIB);					/* free ressource */
	x_gem_exit ();										/* and close Xgem */
}



void gere_keyboard(void)
	{
	WIND_LIST *wind=NULL;
	WIND_INFO *wind_info=NULL;
	OBJECT *adr=NULL;
	GRECT rd;

	wind = &x_gem->wind[x_find_top_wind()];
	wind_info = wind->w_user1;
	adr = wind->w_dial.d_addr;

	if(x_gem->key==29440 || x_gem->key==29696 || x_gem->key==18432 || x_gem->key==20480 || x_gem->key==20530 || x_gem->key==18488)				/* Control + arrows		*/
		{
		switch(x_gem->key)
			{
			case 29440:				/* Left	+ Ctrl	*/
				if(wind->w_pos_x>20)
					wind->w_pos_x -= 20;
				break;
			case 29696:				/* Right + Ctrl	*/
				if(wind->w_pos_x<(wind->w_nb_col-wind->w_nb_vcol))
					wind->w_pos_x += 20;
				break;
			case 18432:				/* Up	*/
				if(wind->w_pos_y>20)
					wind->w_pos_y -= 20;
				break;
			case 20480:				/* Down	*/
				if(wind->w_pos_y<(wind->w_nb_lig-wind->w_nb_vlig-20))
					wind->w_pos_y += 20;
				break;

			case 20530:				/* Down + Shift	*/
				if(wind->w_pos_y<(wind->w_nb_lig-wind->w_nb_vlig-100))
					wind->w_pos_y += 100;
				break;

			case 18488:				/* Up + Shift	*/
				if(wind->w_pos_y>100)
					wind->w_pos_y -= 100;
				break;
				
			}
		if(wind->w_old_pos_x!=wind->w_pos_x || wind->w_old_pos_y!=wind->w_pos_y)
			{
			x_set_slider_wind (x_find_top_wind(), SET_HSLIDE|SET_VSLIDE);
			x_window_arrowed(x_find_top_wind());
			x_redraw_wind (x_find_top_wind(), DRAW_VDI, ROOT, &wind->w_work_wind);
			}
		}
	else if(x_gem->key==19712)		/* RIGHT	*/
		{
		if(wind_info->pdf_info->pages->max_to_load > wind_info->pdf_info->page_no)
			{
			wind_info->pdf_info->page_no++;

			rd.g_x = adr->ob_x + adr[NEXT_TB].ob_x;
			rd.g_y = adr->ob_y + adr[NEXT_TB].ob_y;
			rd.g_w = rd.g_x + adr[NEXT_TB].ob_width;
			rd.g_h = rd.g_y + adr[NEXT_TB].ob_height;
			adr[NEXT_TB].ob_state |= SELECTED;
			x_redraw_wind (x_find_top_wind(), DRAW_AES, NEXT_TB, &rd);		
			evnt_timer(100L);
			adr[NEXT_TB].ob_state &= ~SELECTED;
			x_redraw_wind (x_find_top_wind(), DRAW_AES, NEXT_TB, &rd);

			update_pdf_window (x_find_top_wind());
			}
		}
	else if(x_gem->key==19200)		/* LEFT	*/
		{
		if(wind_info->pdf_info->page_no > 1)
			{
			wind_info->pdf_info->page_no--;

			rd.g_x = adr->ob_x + adr[PREV_TB].ob_x;
			rd.g_y = adr->ob_y + adr[PREV_TB].ob_y;
			rd.g_w = rd.g_x + adr[PREV_TB].ob_width;
			rd.g_h = rd.g_y + adr[PREV_TB].ob_height;
			adr[PREV_TB].ob_state |= SELECTED;
			x_redraw_wind (x_find_top_wind(), DRAW_AES, PREV_TB, &rd);		
			evnt_timer(100L);
			adr[PREV_TB].ob_state &= ~SELECTED;
			x_redraw_wind (x_find_top_wind(), DRAW_AES, PREV_TB, &rd);

			update_pdf_window (x_find_top_wind());
			}
		}

	else if(x_gem->key==19766)		/* Shift + RIGHT	*/
		{
		wind_info->pdf_info->page_no = wind_info->pdf_info->pages->max_to_load;

		rd.g_x = adr->ob_x + adr[LAST_TB].ob_x;
		rd.g_y = adr->ob_y + adr[LAST_TB].ob_y;
		rd.g_w = rd.g_x + adr[LAST_TB].ob_width;
		rd.g_h = rd.g_y + adr[LAST_TB].ob_height;
		adr[LAST_TB].ob_state |= SELECTED;
		x_redraw_wind (x_find_top_wind(), DRAW_AES, LAST_TB, &rd);		
		evnt_timer(100L);
		adr[LAST_TB].ob_state &= ~SELECTED;
		x_redraw_wind (x_find_top_wind(), DRAW_AES, LAST_TB, &rd);

		update_pdf_window (x_find_top_wind());
		}

	else if(x_gem->key==19252)		/* Shift + LEFT	*/
		{
		wind_info->pdf_info->page_no = 1;

		rd.g_x = adr->ob_x + adr[FIRST_TB].ob_x;
		rd.g_y = adr->ob_y + adr[FIRST_TB].ob_y;
		rd.g_w = rd.g_x + adr[FIRST_TB].ob_width;
		rd.g_h = rd.g_y + adr[FIRST_TB].ob_height;
		adr[FIRST_TB].ob_state |= SELECTED;
		x_redraw_wind (x_find_top_wind(), DRAW_AES, FIRST_TB, &rd);		
		evnt_timer(100L);
		adr[FIRST_TB].ob_state &= ~SELECTED;
		x_redraw_wind (x_find_top_wind(), DRAW_AES, FIRST_TB, &rd);

		update_pdf_window (x_find_top_wind());
		}
	}




void gere_messages (void)
{
	unsigned long av_adres=0;
	short ec, window;
	GRECT rd;
	OBJECT *adr;
	WIND_LIST *wind;
	WIND_INFO *wind_info;

	switch (x_gem->event_buffer[0])						/* which is the message ? */
	{
		case VA_START:
		case PDF_AV_SHOW_INFO:
		case PDF_AV_OPEN_FILE:
			{
				unsigned long adr1, adr2;
				adr1 = (((unsigned long)x_gem->event_buffer[3])<<16);
				adr2 = ((unsigned long)x_gem->event_buffer[4]);
				av_adres = (adr1&0xffff0000) | (adr2&0xffff);
				if (open_pdf_window ((char*)av_adres) == TRUE)
					{
					add_file_to_list((char*)av_adres);
					Send_AV(x_gem->event_buffer[1], PDF_AV_DONE_OK, NULL, NULL);
					}
				else
					Send_AV(x_gem->event_buffer[1], PDF_AV_DONE_FALSE, NULL, NULL);
				if(x_gem->event_buffer[0]==PDF_AV_SHOW_INFO)
					{
					window = x_find_top_wind();
					wind = &x_gem->wind[window];
					wind_info = (WIND_INFO *)wind->w_user1;
					Show_pdf_info (wind_info->pdf_info);
					}
				break;
			}
		case AP_DRAGDROP:
		/*	open_pdf_window ((char*)&(x_gem->event_buffer[13]));	*/
		break;
		case AP_TERM:
			quit = 1;
		break;

		case MN_SELECTED:								/* mouse on the menu... */
/*			Send_AV(x_gem->ap_id, PDF_AV_OPEN_FILE, "d:\\download\\atari\\programowanie\\nr\\c0-0.pdf", NULL);
*/
			if (x_gem->event_buffer[7] == 0)			/* (0: menu, 1: sub-menu) */
				gere_menu ();
			else if(x_gem->event_buffer[5]==(((long)adr_last_files)>>16) && x_gem->event_buffer[6]==((int)adr_last_files))
				open_pdf_window (last_10_files[x_gem->event_buffer[4]-1]);			/* Last opened files		*/
			else if(x_gem->event_buffer[5]==(((long)adr_popup_windows)>>16) && x_gem->event_buffer[6]==((int)adr_popup_windows))
				Take_to_top(x_gem->event_buffer[4]);
			break;

		case WM_CLOSED:									/* window the close... */
			x_close_wind (x_gem->event_wind);
		break;
		case WM_FULLED:									/* for the left toolbar */
		case WM_SIZED:
			window = x_gem->event_wind;

			if(options.history&HISTORY_SLIDER)
				add2history = TRUE;
			else
				add2history = FALSE;

			if (window >= 0)
			{
				wind = &x_gem->wind[window];
				adr = wind->w_dial.d_addr;
				ec = abs (wind->w_curr_wind.g_h - wind->w_old_curr.g_h);
				if (ec)
				{
					wind_info = (WIND_INFO *)wind->w_user1;
					x_init_slider (adr, UP_TB, DOWN_TB, VCUR_TB, VBAR_TB, 1, adr[DTREE_TB].ob_height / OUTLINE_HEIGHT, wind_info->outline_number, wind_info->outline_pos, 0);
					rd.g_x = adr->ob_x;
					rd.g_y = adr->ob_y + adr[IBAR_TB].ob_height + adr[VTBAR_TB + 1].ob_height;
					rd.g_w = adr[VTBAR_TB].ob_width;
					rd.g_h = adr->ob_height;
					x_redraw_wind (window, DRAW_AES, ROOT, &rd);
				}
			}
		break;
	}
}


short stupid(short pos, short max)
{
	WIND_LIST *wind;
	WIND_INFO *wind_info;

	max=max;
	wind = &x_gem->wind[x_find_top_wind()];
	wind_info = wind->w_user1;
	wind_info->outline_pos = pos;
	x_redraw_wind (x_find_top_wind(), DRAW_AES, DTREE_TB, &x_gem->desk_size);

	return(pos);
}



int gere_fenetres (void)
{
	char pdf_file_name[256];
	short obj, window, outline_nr=0, item=0, event=0;
	GRECT rd;
	OBJECT *adr=NULL, *adr2=NULL;
	WIND_LIST *wind=NULL;
	WIND_INFO *wind_info=NULL;
	struct PDF_Info *pdf_info=NULL;
	struct PDF_Outline_dictionary *outline=NULL;

	if ((window = x_gem->event_wind) < 0)
		return(-1);

	obj = *x_gem->object;

	if(window==wind_options_handle)										/* Handle the options window				*/
		{
		handle_options_window(obj);
		return(TRUE);
		}

	if(window==window_page_info_handle)								/* Handle the page info window			*/
		{
		handle_page_info(window, obj);
		return(TRUE);
		}


	wind = &x_gem->wind[window];

	if (wind->w_iconify)
		return(-1);

	adr = wind->w_dial.d_addr;
	wind_info = wind->w_user1;
	if(wind_info)
		pdf_info = wind_info->pdf_info;

	if(obj>=0 && options.bubble_time==-1 && x_gem->mk==2)				/* Do we support BubbleHelp with the right mouse button?	*/
		{
		if(adr[obj].ob_flags&SELECTABLE)
			{
			adr[obj].ob_state &= ~SELECTED;
			x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			}
		if(Check_bubble(1)==TRUE)
			return(TRUE);
		}


	if (pdf_info)
	{
		switch (obj)
		{
			case DTREE_TB:
				graf_mouse (BUSYBEE, 0L);

				objc_offset (adr, DTREE_TB, &rd.g_x, &rd.g_y);

				outline_nr = x_gem->my - rd.g_y - 2;
				outline_nr = outline_nr / OUTLINE_HEIGHT;
				outline_nr ++;

				outline = Find_outline_no (pdf_info->Outline->first_object, wind_info->outline_pos + outline_nr, 0);
	
				if (outline->First > 0 && ! outline->first)
					outline->first = read_outline_dict (pdf_info, (int)outline->First, (int)outline->Count);
	
				if (outline->opened && outline->first)
					outline->opened = 0;
				else if (! outline->opened && outline->first)
					outline->opened = 1;

				obj = pdf_info->page_no;
				pdf_info->page_no = Find_Page_Number_by_Outline (pdf_info, outline);
				pdf_info->page_no++;
				if (pdf_info->page_no <= 0)
					pdf_info->page_no = 1;

				wind_info->outline_number = get_outline_number (0, pdf_info->Outline->first_object);

				graf_mouse (ARROW, 0L);

				if ((obj != pdf_info->page_no) || (outline->First))
				{
					x_init_slider (adr, UP_TB, DOWN_TB, VCUR_TB, VBAR_TB, 1, adr[DTREE_TB].ob_height / OUTLINE_HEIGHT, wind_info->outline_number, 0, 1);
					x_init_slider (adr, LEFT_TB, RIGHT_TB, HCUR_TB, HBAR_TB, 0, wind_info->max_width / 2, wind_info->max_width, 0, 1);

					rd.g_w = adr[DTREE_TB].ob_width;
					rd.g_h = adr[DTREE_TB].ob_height;
					x_redraw_wind (window, DRAW_AES, DTREE_TB, &rd);

					if (! ((outline->First) && (obj == pdf_info->page_no)))
						update_pdf_window (window);
				}
			break;			
			case SELSIZE_TB:
				x_pop_up (x_gem->mx, x_gem->my, adr_popup_zoom, &adr2, &item);			/* call the popup */

				if(options.history&HISTORY_ZOOM)
					add2history = TRUE;
				else
					add2history = FALSE;

				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);

				if(item>=ZOOM_100 && item<=ZOOM_CUSTOM)
					{
					pdf_info->zoom = item;
					update_pdf_window(window);
					}
			break;

			case GLASS_TB:
				pdf_info->zoom = ZOOM_CUSTOM;

				Change_pointer (ZOOM_POINTER);

				do													/* gem loop for events */
				{
					event = x_form_do (0L);							/* let Xgem works... */
				} while (! (event&MU_BUTTON));

				pdf_info->zoom_x = x_gem->mx;
				pdf_info->zoom_y = x_gem->my;
				graf_rubberbox( x_gem->mx, x_gem->my, 20, 20, (INT16*)&pdf_info->zoom_w,	(INT16*)&pdf_info->zoom_h );

/*				graf_shrinkbox(pdf_info->zoom_x, pdf_info->zoom_y, pdf_info->zoom_w, pdf_info->zoom_h,
												0, 0, 800, 608);

				graf_growbox(pdf_info->zoom_x, pdf_info->zoom_y, pdf_info->zoom_w, pdf_info->zoom_h,
												0, 0, 800, 608);
*/
				if(options.history&HISTORY_ZOOM)
					add2history = TRUE;
				else
					add2history = FALSE;

				pdf_info->zoom_w >>= 16;
				pdf_info->zoom_h >>= 16;

				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
				Change_pointer(0);

				update_pdf_window (window);
			break;
			case PAGE_TB:
				Get_GoToPage(pdf_info);
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
				update_pdf_window (window);
			break;
			case FIRST_TB:
				pdf_info->page_no = 1;
				update_pdf_window (window);
				evnt_timer(100L);
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			break;
			case PREV_TB:
				if(pdf_info->page_no>1)
					pdf_info->page_no--;
				update_pdf_window(window);
				evnt_timer(100L);
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			break;
			case NEXT_TB:
				if(pdf_info->pages->max_to_load>pdf_info->page_no)
					pdf_info->page_no++;
				update_pdf_window (window);
				evnt_timer(100L);
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			break;
			case LAST_TB:
				pdf_info->page_no = pdf_info->pages->max_to_load;
				update_pdf_window (window);
				evnt_timer(100L);
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			break;
			case SELPAGE_TB:
				Get_GoToPage(pdf_info);
				update_pdf_window (window);
				evnt_timer(100L);
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			break;
			case LEFT_TB:
			case RIGHT_TB:
			case HCUR_TB:
			case HBAR_TB:
				x_use_slider (adr, obj, LEFT_TB, RIGHT_TB, HCUR_TB, HBAR_TB, 0, 2, wind_info->max_width, &wind_info->outline_pos_x, 0L, 0L);
				rd.g_x = adr->ob_x;
				rd.g_y = adr->ob_y + adr[IBAR_TB].ob_height + adr[VTBAR_TB + 1].ob_height;
				rd.g_w = adr[VTBAR_TB].ob_width;
				rd.g_h = adr->ob_height;
				x_redraw_wind (window, DRAW_AES, DTREE_TB, &rd);
			break;
			case UP_TB:
			case VBAR_TB:
			case VCUR_TB:
			case DOWN_TB:
				x_use_slider (adr, obj, UP_TB, DOWN_TB, VCUR_TB, VBAR_TB, 1, adr[DTREE_TB].ob_height / OUTLINE_HEIGHT, wind_info->outline_number, &wind_info->outline_pos, 0L, 0L);
				rd.g_x = adr->ob_x;
				rd.g_y = adr->ob_y + adr[IBAR_TB].ob_height + adr[VTBAR_TB + 1].ob_height;
				rd.g_w = adr[VTBAR_TB].ob_width;
				rd.g_h = adr->ob_height;
				x_redraw_wind (window, DRAW_AES, DTREE_TB, &rd);
			break;

			case INFO_TB:
				Show_pdf_info (pdf_info);
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			break;

			case INFO_TB_PAGE:
				open_page_info ();
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			break;


			case OPEN_TB:
				if (x_file_select (1, STR (DI_OPEN), "*.PDF", options.paths.default_pdf_dir, pdf_file_name))
				{
					if (open_pdf_window (pdf_file_name) == TRUE)
						add_file_to_list (pdf_file_name);
				}
				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
			break;

			case REAR_TB:

				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);

				pdf_info->prev_pos.prev_pos = pdf_info->prev_pos.act_pos;

				if(pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos].page_no==-1 && pdf_info->prev_pos.act_pos>=1)
					pdf_info->prev_pos.act_pos--;

				if(pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos].saved == TRUE && pdf_info->prev_pos.act_pos>=1)
					{
					pdf_info->page_no = pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos-1].page_no;
					pdf_info->zoom = (int)pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos-1].zoom;

					if(pdf_info->prev_pos.act_pos>=0)
						{
						pdf_info->prev_pos.act_pos--;
						adr[obj].ob_state &= ~DISABLED;
						}

					if(pdf_info->prev_pos.act_pos==0)
						adr[obj].ob_state |= DISABLED;
					x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);

					if(pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos+1].saved == TRUE)
						adr[FORWARD_TB].ob_state &= ~DISABLED;
					else
						adr[FORWARD_TB].ob_state |= DISABLED;
					x_redraw_wind (window, DRAW_AES, FORWARD_TB, &x_gem->desk_size);


					add2history = FALSE;
					x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
					update_pdf_window (window);
					}
				if(options.history&HISTORY_PAGES)
					add2history = TRUE;

				break;


			case FORWARD_TB:

				adr[obj].ob_state &= ~SELECTED;
				x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);

				pdf_info->prev_pos.prev_pos = pdf_info->prev_pos.act_pos;

				if(pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos+1].saved == TRUE )
					{
					pdf_info->page_no = pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos+1].page_no;
					pdf_info->zoom = (int)pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos+1].zoom;

					if(pdf_info->prev_pos.act_pos<19)
						{
						pdf_info->prev_pos.act_pos++;
						adr[REAR_TB].ob_state &= ~DISABLED;
						x_redraw_wind (window, DRAW_AES, REAR_TB, &x_gem->desk_size);
						}

					if(pdf_info->prev_pos.jump[pdf_info->prev_pos.act_pos+1].saved == TRUE || pdf_info->prev_pos.act_pos==19)
						adr[FORWARD_TB].ob_state &= ~DISABLED;
					else
						adr[FORWARD_TB].ob_state |= DISABLED;

					add2history = FALSE;
					x_redraw_wind (window, DRAW_AES, obj, &x_gem->desk_size);
					update_pdf_window (window);
					}

				if(options.history&HISTORY_PAGES)
					add2history = TRUE;
				
				break;

			case TREE_TB:
				if(adr[TREE_TB].ob_state&SELECTED)
					pdf_info->rand_type = 3;									/* Nothing	*/
				else
					{
					pdf_info->rand_type = 0;
					adr[THUMB_TB].ob_state &= ~SELECTED;
					adr[THREADS_TB].ob_state &= ~SELECTED;
					x_redraw_wind (window, DRAW_AES, THUMB_TB, &x_gem->desk_size);
					x_redraw_wind (window, DRAW_AES, THREADS_TB, &x_gem->desk_size);
					}
				break;

			case THUMB_TB:
				if(adr[THUMB_TB].ob_state&SELECTED)
					pdf_info->rand_type = 3;									/* Nothing	*/
				else
					{
					pdf_info->rand_type = 1;
					adr[TREE_TB].ob_state &= ~SELECTED;
					adr[THREADS_TB].ob_state &= ~SELECTED;
					x_redraw_wind (window, TREE_TB, THUMB_TB, &x_gem->desk_size);
					x_redraw_wind (window, DRAW_AES, THREADS_TB, &x_gem->desk_size);
					}
				break;

			case THREADS_TB:
				if(adr[THREADS_TB].ob_state&SELECTED)
					pdf_info->rand_type = 3;									/* Nothing	*/
				else
					{
					pdf_info->rand_type = 2;
					adr[TREE_TB].ob_state &= ~SELECTED;
					adr[THUMB_TB].ob_state &= ~SELECTED;
					x_redraw_wind (window, TREE_TB, THUMB_TB, &x_gem->desk_size);
					x_redraw_wind (window, THUMB_TB, THREADS_TB, &x_gem->desk_size);
					}
				break;


			default:
				gere_popup (window);
		}
	}
	return(TRUE);
}



/* ******************************************************************		*	*/
/* * Get_GoToPage (24.04.2002)																					*	*/
/* ******************************************************************		*	*/
/* * v. 1.00 (23.04.2002)	- First version																*	*/
/* * v. 1.01 (24.04.2002) - Second better version (support for both			*	*/
/* *												page numbering styles - real and PDF)				*	*/
/* *																																		*	*/
/* * v. 1.02 (24.05.2002) - some small changes													*	*/

void Get_GoToPage (struct PDF_Info *info)
{
	char number[10]={0}, number2[10]={0};
	short obj, i, prev_page;
	DIAL_INFO dial;

	prev_page = info->page_no;

	adr_gotopage[PAGE_REAL_NUMBER].ob_flags &= SELECTABLE;

	if (adr_gotopage[PAGE_REAL_NUMBER].ob_state & SELECTED)		/* Should we show the real number? */
		itoa ((short)info->page_no, x_get_ob_text(adr_gotopage, PAGE_EDIT), 10);
	else																											/* or the PDF number? */
		PageNumber (info, (short)info->page_no, x_get_ob_text(adr_gotopage, PAGE_EDIT));

	x_open_dial (adr_gotopage, &dial, 0, 0, 0L);

	for (;;)													/* classic xgem loop... */
	{
		x_form_do (&dial);
		if (x_gem->event & MU_BUTTON)
		{
			obj = *x_gem->object;
			switch (obj)
			{
				case PAGE_GO:									/* Go to the new page */
					goto exit_dial;
				case PAGE_CANCEL:								/* Stay at the same page */
					info->page_no = prev_page;
					goto exit_dial;
				case PAGE_RIGHT:								/* Add 1 to the page number	*/
					if (info->page_no < info->pages->max_to_load)
						info->page_no +=2;
					else
						break;
				case PAGE_LEFT:
					if (info->page_no > 1)
					{
						info->page_no --;

						objc_edit (adr_gotopage, PAGE_EDIT, 0, &dial.d_pos_edit, ED_END);
						if (adr_gotopage[PAGE_REAL_NUMBER].ob_state & SELECTED)
							itoa ((short)info->page_no, x_get_ob_text (adr_gotopage, PAGE_EDIT), 10);
						else
							PageNumber (info, (short)info->page_no, x_get_ob_text (adr_gotopage, PAGE_EDIT));

						s_objc_draw (adr_gotopage, PAGE_EDIT, MAX_DEPTH, &x_gem->desk_size);
						objc_edit (adr_gotopage, PAGE_EDIT, 0, &dial.d_pos_edit, ED_INIT);

						evnt_timer (100L);
					}
				break;
			}
		}
	}

exit_dial:
	if (obj == PAGE_GO)
	{
		strcpy (number, x_get_ob_text (adr_gotopage, PAGE_EDIT));
		if (adr_gotopage[PAGE_REAL_NUMBER].ob_state & SELECTED)
		{
			i = atoi (x_get_ob_text (adr_gotopage, PAGE_EDIT));
			if (i >= 1 && i <= info->pages->max_to_load)
				info->page_no = i;
		}
		else
		{
			i = 0;
			PageNumber (info, i, number2);
			while (strcmp (number, number2) != 0 && i <= info->pages->max_to_load)
			{
				number2[0] = 0;
				PageNumber (info, i ++, number2);
			}
			info->page_no = i - 1;
		}
	}

	adr_gotopage[obj].ob_state &= ~SELECTED;
	x_close_dial (&dial, obj);
}


void gere_popup (short window)
{
	char pdf_file_name[512];
	struct PDF_Info *pdf_info=NULL;
	WIND_LIST *wind;
	WIND_INFO *wind_info=NULL;
	OBJECT *adr;
	short item;

	wind = &x_gem->wind[window];

	if (wind->w_iconify)
		return;

	wind_info = wind->w_user1;
	pdf_info = wind_info->pdf_info;

	if(Check_bubble(1)==TRUE)
		return;


	if (window >= 0 && x_gem->mk==1)											/* if the mouse is aboce a picture */
		{
		if(pdf_info->over_picture==TRUE && x_gem->nb_clik==2)
			{
			struct page_contents *page=NULL;
			struct picture *pic=NULL;

			page = (struct page_contents *)(pdf_info->pages_contents[0].adress);
			pic = page->resource->pictures;

			pic = &pic[pdf_info->over_picture_no];
			if(strlen(pic->name)>0)
				{
				char dummy[16]={0};
				sprintf(dummy, "~41%s", pic->name);
				x_set_ob_text (adr_popup_over_picture, POPUP_PIC_NAME, dummy);
				}
			else
				x_set_ob_text (adr_popup_over_picture, POPUP_PIC_NAME, "~41Picture name");

			if(pic->show==TRUE)
				x_set_ob_text (adr_popup_over_picture, POPUP_PIC_SHOW, x_get_ob_text (adr_strings, POP_IMG_TXT_HIDE));
			else
				x_set_ob_text (adr_popup_over_picture, POPUP_PIC_SHOW, x_get_ob_text (adr_strings, POP_IMG_TXT_SHOW));

			if (x_pop_up (x_gem->mx, x_gem->my, adr_popup_over_picture, &adr, &item))					/* call the popup */
				{
				if (adr == adr_popup_over_picture)
					{
					switch (item)
						{
						case POPUP_PIC_INFO:
							{
							char *buffer=calloc(1, 512);
							char *format[]={"unknown", "AsciiHexDecode", "Ascii85Decode",
															"LZW Decode", "FlateDecode", "RLE", "CCITT Fax Decode", "DCTDecode (JPEG)", NULL};

							sprintf(buffer, "[3][Size:| Width =  %5d| Height = %5d| Planes = %5d| Format = %s][OK]",
											(int)pic->width, (int)pic->height, (int)pic->BitsPerComponent, format[pic->filter_table[0]]);
							x_gem_alert(buffer, 0L);
							free(buffer);
							break;
							}
						case POPUP_PIC_SAVEAS:
							if(pic->filter_table[0]==DCTDECODE)
								Save_picture(pic->name, &pdf_info->file_info->buffer[pic->stream_pos], pic->Length);
							break;
						case POPUP_PIC_SHOW:
							{
							if(pic->show == TRUE)
								pic->show = FALSE;
							else
								pic->show = TRUE;
							Display_page (wind);
							break;
							}
							break;
						case POPUP_PIC_DITHER:
							break;
						}
					}
				}
			return;
			}
		}

	if (window >= 0 && x_gem->mk==2)											/* if the mouse is in a window */
	{
		wind = &x_gem->wind[window];
		wind_info = wind->w_user1;
		
		
/*
		Update_Threads(wind_info->pdf_info);						/* TO DO!!!	*/
		Update_Outline(wind_info->pdf_info);						/* TO DO!!!	*/
*/

		if (x_pop_up (x_gem->mx, x_gem->my, adr_popup_menu, &adr, &item))					/* call the popup */
		{
			if (adr == adr_popup_menu)
			{
				switch (item)
				{
					case POPUP_M_NEXT_PA:
						if(pdf_info->page_no>1)
							pdf_info->page_no++;
						update_pdf_window (window);
						break;
					case POPUP_M_PREV_PA:
						if (pdf_info->pages->max_to_load>pdf_info->page_no)
							pdf_info->page_no--;
						update_pdf_window (window);
					break;
					case POPUP_M_PAGE:
						Get_GoToPage (pdf_info);
						update_pdf_window (window);
					break;
					case POPUP_M_OPEN:
						if (x_file_select (1, STR (DI_OPEN), "*.PDF", options.paths.default_pdf_dir, pdf_file_name))
						{
							if (open_pdf_window (pdf_file_name) == TRUE)
								add_file_to_list (pdf_file_name);
						}
					break;
					case POPUP_M_CLOSE:
						if (x_gem->event_wind >= 0)
							x_close_wind (x_gem->event_wind);
					break;
					case POPUP_M_INFO:
						Show_pdf_info (wind_info->pdf_info);
					break;
					case POPUP_M_PAGEINFO:
						open_page_info ();
					break;
				}
			}
			else if (adr == adr_popup_zoom)
			{
				pdf_info = wind_info->pdf_info;
				pdf_info->zoom = item;
				update_pdf_window(window);
			}
			else if (adr == adr_popup_windows)
				Take_to_top(item-1);
		}
	}
	else if(x_gem->mk==2)													/* or on desktop */		
	{
		x_pop_up (x_gem->mx, x_gem->my, adr_popup_menu, &adr, &item);
			/* note: an other popup should be a good idea, because
			you can't have the 'close' and the 'informations' items
			(else, on which window should they work ?) */
	}
}


void gere_menu (void)
{
	char buf[256], pdf_file_name[256];
	short window, title;
	WIND_LIST *wind;
	WIND_INFO *wind_info;

	title = x_gem->event_buffer[3];
	window = x_gem->top_wind;
	if (window >= 0)
	{
		wind = &x_gem->wind[window];
		wind_info = wind->w_user1;
	}
	else
	{
		wind = 0L;
		wind_info = 0L;
	}

	switch (x_gem->event_buffer[4])						/* which item ? */
	{
		case M_INFOS:
			sprintf (buf, (char*)ALERT (ALERT1), VERSION, DATE, "1.1.4", ((unsigned long)Malloc(-1))/1000, "kB of", (unsigned long)(options.ava_mem/1000), "kB");
			x_gem_alert (buf, 0L);
		break;
		case M_OPEN:
			if (x_file_select (1, STR (DI_OPEN), "*.PDF", options.paths.default_pdf_dir, pdf_file_name))
			{
				if (open_pdf_window (pdf_file_name))
					add_file_to_list (pdf_file_name);
			}
		break;

		case M_SAVE_AS:
			Save_PDF(window);
			break;

		case M_CLOSE:
			if (window >= 0)
				x_close_wind (window);
		break;
		case M_DOC_INFO:
			if (wind_info)
				Show_pdf_info (wind_info->pdf_info);
		break;
		case M_PAGE_INFO:
			open_page_info();
			break;
		case M_QUIT:
			quit = 1;
		break;
		case M_FIRST_PAGE:
			if (wind_info)
			{
				wind_info->pdf_info->page_no = 1;

				/*adr[FIRST_TB].ob_state |= DISABLED;
				adr[PREV_TB].ob_state |= DISABLED;
				x_redraw_wind (window, DRAW_AES, FIRST_TB, &x_gem->desk_size);
				x_redraw_wind (window, DRAW_AES, PREV_TB, &x_gem->desk_size);*/

				update_pdf_window (window);
			}
		break;
		case M_PREV_PAGE:
			if (wind_info)
			{
				if (wind_info->pdf_info->page_no > 1)
					wind_info->pdf_info->page_no --;

				/*adr[NEXT_TB].ob_state &= ~DISABLED;
				adr[LAST_TB].ob_state &= ~DISABLED;
				x_redraw_wind (window, DRAW_AES, NEXT_TB, &x_gem->desk_size);
				x_redraw_wind (window, DRAW_AES, LAST_TB, &x_gem->desk_size);

				if (wind_info->pdf_info->page_no == wind_info->pdf_info->pages->max_to_load)
				{
					adr[FIRST_TB].ob_state |= DISABLED;
					adr[PREV_TB].ob_state |= DISABLED;
					x_redraw_wind (window, DRAW_AES, FIRST_TB, &x_gem->desk_size);
					x_redraw_wind (window, DRAW_AES, PREV_TB, &x_gem->desk_size);
				}*/

				update_pdf_window (window);
			}
		break;
		case M_NEXT_PAGE:
			if (wind_info)
			{
				if (wind_info->pdf_info->page_no < wind_info->pdf_info->pages->max_to_load)
					wind_info->pdf_info->page_no ++;

				/*adr[FIRST_TB].ob_state &= ~DISABLED;
				adr[PREV_TB].ob_state &= ~DISABLED;
				x_redraw_wind (window, DRAW_AES, FIRST_TB, &x_gem->desk_size);
				x_redraw_wind (window, DRAW_AES, PREV_TB, &x_gem->desk_size);

				if (wind_info->pdf_info->page_no == wind_info->pdf_info->pages->max_to_load)
				{
					adr[NEXT_TB].ob_state |= DISABLED;
					adr[LAST_TB].ob_state |= DISABLED;
					x_redraw_wind (window, DRAW_AES, NEXT_TB, &x_gem->desk_size);
					x_redraw_wind (window, DRAW_AES, LAST_TB, &x_gem->desk_size);
				}*/

				update_pdf_window (window);
			}
		break;
		case M_LAST_PAGE:
			if (wind_info)
			{
				wind_info->pdf_info->page_no = wind_info->pdf_info->pages->max_to_load;

				/*adr[NEXT_TB].ob_state |= DISABLED;
				adr[LAST_TB].ob_state |= DISABLED;
				x_redraw_wind (window, DRAW_AES, NEXT_TB, &x_gem->desk_size);
				x_redraw_wind (window, DRAW_AES, LAST_TB, &x_gem->desk_size);*/

				update_pdf_window (window);
			}
		break;
		case M_GOTOPAGE:
			if (wind_info)
			{
				Get_GoToPage (wind_info->pdf_info);
				update_pdf_window (window);
			}
		break;

		case M_FULL_SCREEN:
		break;
		case M_ZOOM_IN:
			if (ZOOM_300 > wind_info->pdf_info->zoom && wind_info->pdf_info->zoom >= ZOOM_25)
				wind_info->pdf_info->zoom ++;
			else
				wind_info->pdf_info->zoom = ZOOM_25;			/* TO BE DONE LATER !!!	*/
			update_pdf_window (window);
		break;
		case M_ZOOM_OUT:
			if (ZOOM_300 >= wind_info->pdf_info->zoom && wind_info->pdf_info->zoom > ZOOM_25)
				wind_info->pdf_info->zoom --;
			else
				wind_info->pdf_info->zoom = ZOOM_25;			/* TO BE DONE LATER !!!	*/
			update_pdf_window (window);
		break;
		case M_ZOOM_TO:
		break;
		case M_FIT_IN_WIND:
			wind_info->pdf_info->zoom = ZOOM_FULLPAGE;
			update_pdf_window (window);
		break;
		case M_ACT_SIZE:
		break;
		case M_FIT_WIDTH:
			wind_info->pdf_info->zoom = ZOOM_PAGEWIDTH;
			update_pdf_window (window);
		break;
		case M_FIT_VISIBLE:
			update_pdf_window (window);
		break;
		case M_REFLOW:
			update_pdf_window (window);
		break;

		case M_OPTIONS:
			open_options_dialog();
			break;
		case M_SAVE_OPTIONS:
			Save_options(TRUE);
			break;
		case M_LOAD_OPTIONS:
			Load_options();
			break;

		case M_CHANGE_INFO:
			if(wind_info)
				Change_document_info(wind_info);
			break;
	}

	menu_tnormal (adr_menu, title, 1);
}



/* *********************************************** */
/* Adding a window to the window list							 */
/* *********************************************** */

void add_window_to_popup(int window, char *title)
	{
	int i=0;

	adr_popup_windows->ob_height = 0;
	for(i=0; i<20; i++)
		{
		adr_popup_windows->ob_height += 16;
		if(windows_popup[i].empty==TRUE)
			{
			windows_popup[i].handle = window;
			sprintf(windows_popup[i].name, "%.16s", title);
			windows_popup[i].empty = FALSE;
			x_set_ob_text(adr_popup_windows, i+1, windows_popup[i].name);
			adr_popup_windows[i+1].ob_state &= ~DISABLED;
			break;
			}
		}
	}

void Delete_window_from_popup(int window)
	{
	int i;

	for(i=0; i<20; i++)
		{
		if(windows_popup[i].empty==FALSE && windows_popup[i].handle==window)
			{
			windows_popup[i].handle = 0;
			windows_popup[i].empty = TRUE;
			strnset(windows_popup[i].name, ' ', 20);
			x_set_ob_text(adr_popup_windows, i+1, " ");
			break;
			}
		}

	i++;
	for(; i<20; i++)
		{
		if(windows_popup[i].empty==FALSE)
			{
			add_window_to_popup(windows_popup[i].handle, windows_popup[i].name);
			windows_popup[i].handle = 0;
			windows_popup[i].empty = TRUE;
			strnset(windows_popup[i].name, ' ', 20);
			x_set_ob_text(adr_popup_windows, i+1, " ");
			}
		}
	}

void Take_to_top(int window)
	{
	if(windows[windows_popup[window-1].handle].w_iconify)
		{
		windows[windows_popup[window-1].handle].w_iconify = FALSE;
		wind_set (windows[windows_popup[window-1].handle].w_hand, WF_UNICONIFY, 
				windows[windows_popup[window-1].handle].w_curr_wind.g_x, windows[windows_popup[window-1].handle].w_curr_wind.g_y,
				windows[windows_popup[window-1].handle].w_curr_wind.g_w, windows[windows_popup[window-1].handle].w_curr_wind.g_h);
		}
	
	wind_set (windows[windows_popup[window-1].handle].w_hand, WF_TOP, 0, 0, 0, 0);
	}

/* *********************************************** */


void switch_menu_entries(int mode)
	{
	int i;
	int what[]={M_SAVE_AS, M_CLOSE, M_DOC_INFO, M_PAGE_INFO, M_PRINT, M_FULL_SCREEN, M_ZOOM_IN, M_ZOOM_OUT, M_ZOOM_TO, M_FIT_IN_WIND, M_ACT_SIZE, M_FIT_WIDTH, M_FIT_VISIBLE, M_REFLOW, M_WINDOWS, -1};

	for(i=M_FIRST_PAGE; i<(M_GOTOPAGE+1); i++)
		menu_ienable( adr_menu, i, mode);
	for(i=0; what[i]!=-1; i++)
		menu_ienable (adr_menu, what[i], mode);
	}

/* *********************************************** */


	/* open a pdf document in a window */
short open_pdf_window (char *name)
{
	char buf[256]={0}, buf2[256]={0};
	short win_w, win_h, window, i;
	WIND_LIST *wind;
	static ICON_LIST icw = {0, 8, 8, 32, 32, IL_USER, 0L, 0L};	/* for iconify */
	OBJECT *adr;
	WIND_INFO *wind_info;
	struct PDF_Info *pdf_info;
	struct PDF_Outline *outline;

	pdf_info = Add_PDF_Info ();
	if (! pdf_info)
		return (FALSE);

	if (Check_if_pdf (name, pdf_info))						/* Checks if the choosen file is a PDF document, opens a file structure, loads the document to memory */
	{
		if (Load_pdf_info (pdf_info))
		{
			Change_status (STATUS_WIN_CLOSE, 0, 0);			/* close the status window */
			while (x_form_do (0L) != MU_TIMER);				/* better to wait the status window is really closed */

			pdf_info->page_no = 1;
			pdf_info->zoom = ZOOM_FULLPAGE;
			if (options.system.protocols&PROT_DHST)
			{
				if(pdf_info->Title!=NULL)
					DHST_write( x_gem->ap_id, opened_pdf+1, "MyPDF", options.paths.app_dir, pdf_info->Title, name);
				else if(pdf_info->Subject!=NULL)
					DHST_write( x_gem->ap_id, opened_pdf+1, "MyPDF", options.paths.app_dir, pdf_info->Subject, name);
				else
					DHST_write( x_gem->ap_id, opened_pdf+1, "MyPDF", options.paths.app_dir, name, name);
			}

			if (options.paths.default_pdf_dir!=NULL)
			{
				options.paths.default_pdf_dir = Free_and_alloc((void*)options.paths.default_pdf_dir, strlen(name)+3);
				strcpy(options.paths.default_pdf_dir, name);
				x_cut_dirname(options.paths.default_pdf_dir);
			}

			if (pdf_info->file_info->handle>0)
			{
				close(pdf_info->file_info->handle);
				pdf_info->file_info->handle = open(name, O_RDONLY);
			}

				/* find a good title (Title, Subject, or file name)... */
			strcpy (buf2, name);
			x_cut_filename (buf2);
			if (pdf_info->Title)
			{
				if (strlen (pdf_info->Title) > 25)
					sprintf (buf, "MyPDF: %-25s... (%-13s)", pdf_info->Title, buf2);
				else
					sprintf (buf, "MyPDF: %-25s (%-13s)", pdf_info->Title, buf2);
			}
			else if (pdf_info->Subject)
			{
				if (strlen (pdf_info->Subject) > 25)
					sprintf (buf, "MyPDF: %-25s... (%-13s)", pdf_info->Subject, buf2);
				else
					sprintf (buf, "MyPDF: %-25s (%-13s)", pdf_info->Subject, buf2);
			}
			else
				sprintf (buf, "MyPDF: %s", buf2);

				/* get max size of a window (desk size): */
			win_w = x_gem->desk_size.g_w;
			win_h = x_gem->desk_size.g_h;

			window = x_open_wind (-1, -1, adr_toolbar[VTBAR_TB].ob_width, adr_toolbar[IBAR_TB].ob_height + adr_toolbar[HTBAR_TB].ob_height + 1, 0, 0, win_w, win_h, win_w, win_h, 1, 1, 1, 1,
			 CLOSER|NAME|MOVER|FULLER|UPARROW|VSLIDE|DNARROW|SIZER|RTARROW|HSLIDE|LFARROW, buf, "", 0L, adr_toolbar, &icw, 0L, adapt_pdf_window, redraw_pdf_window, close_pdf_window, 0L);

			if (window >= 0)
			{				
				add_window_to_popup(window, &buf[7]);

					/* get the window structure: */
				wind = &windows[window];
				pdf_info->window_handle = wind->w_hand;				/* VDI Window handler	*/
				pdf_info->window_number = window;							/* Window number			*/

					/* get toolbar address: */
				adr = wind->w_dial.d_addr;

					/* set special window info (for displaying outline in the toolbar and other things) */
				wind_info = (WIND_INFO *)malloc (sizeof (WIND_INFO));

				wind_info->pdf_info = pdf_info;

				wind_info->pdf_object = 0L;

				wind_info->outline_tb.ub_code = display_outline;
				wind_info->outline_tb.ub_parm = (long)wind;
				wind_info->outline_pos = 0;
				outline = pdf_info->Outline;
				if(outline)
					{
					if (outline->first_object)
						wind_info->outline_number = get_outline_number (0, outline->first_object);
					else
						adr[TREE_TB].ob_state |= DISABLED;
					}
				else
					adr[TREE_TB].ob_state |= DISABLED;

				if(pdf_info->thumb==NULL)
					adr[THUMB_TB].ob_state |= DISABLED;

				if(pdf_info->Threads==NULL)
					adr[THREADS_TB].ob_state |= DISABLED;

				adr[DTREE_TB].ob_type = G_USERDEF|0x6400;
				adr[DTREE_TB].ob_spec.userblk = &wind_info->outline_tb;
				adapt_pdf_window (window);
				x_init_slider (adr, UP_TB, DOWN_TB, VCUR_TB, VBAR_TB, 1, adr[DTREE_TB].ob_height / OUTLINE_HEIGHT, wind_info->outline_number, 0, 0);
				wind_info->outline_pos_x = wind_info->max_width = 0;
				x_init_slider (adr, LEFT_TB, RIGHT_TB, HCUR_TB, HBAR_TB, 0, wind_info->max_width/3, wind_info->max_width, 0, 0);

					/* set pdf info in the window: */
				wind->w_user1 = wind_info;

					/* Interface doesn't like icons with 24 points width :( */
				adr[TREE_TB].ob_width = adr[THUMB_TB].ob_width = adr[INFO_TB].ob_width = adr[OPEN_TB].ob_width = adr[PRINT_TB].ob_width = adr[FIND_TB].ob_width = adr[GLASS_TB].ob_width = adr[FIRST_TB].ob_width = adr[PREV_TB].ob_width =
				 adr[INFO_TB_PAGE].ob_width = adr[NEXT_TB].ob_width = adr[LAST_TB].ob_width = adr[REAR_TB].ob_width = adr[FORWARD_TB].ob_width = 24;


				adr[TREE_TB].ob_state &= ~SELECTED;
				adr[THUMB_TB].ob_state &= ~SELECTED;
				adr[THREADS_TB].ob_state &= ~SELECTED;

				if(pdf_info->Outline)
					{
					if(pdf_info->Outline->Count==0 && pdf_info->thumb!=NULL)
						adr[THUMB_TB].ob_state |= SELECTED;
					if(pdf_info->Outline->Count==0 && pdf_info->Threads!=NULL && pdf_info->thumb==NULL)
						adr[THREADS_TB].ob_state |= SELECTED;
					if(pdf_info->Outline->Count!=0)
						{
						adr[TREE_TB].ob_state |= SELECTED;
						adr[THUMB_TB].ob_state &= ~SELECTED;
						adr[THREADS_TB].ob_state &= ~SELECTED;
						}
					}
				else
					{
					adr[TREE_TB].ob_state |= SELECTED;
					adr[THUMB_TB].ob_state &= ~SELECTED;
					adr[THREADS_TB].ob_state &= ~SELECTED;
					}


				adr[EXT_TB].ob_width = 17;

/*					/* An other little thing for Interface ;) */
				adr[LEFT_TB].ob_x = -1;
*/
					/* set the progress bar: */
				adr[PBAR_TB].ob_width = 2;
				adr[PBAR_TB2].ob_width = 2;

					/* clear text: */
				x_set_ob_text (adr, TBAR_TB, "Please wait...");
				x_set_ob_text (adr, SIZE_TB, "");
				x_set_ob_text (adr, PAGE_TB, "");


				for(i=0; i<20; i++)
					{
					pdf_info->prev_pos.jump[i].page_no = -1;
					pdf_info->prev_pos.jump[i].pos_x = 0;
					pdf_info->prev_pos.jump[i].pos_y = 0;
					pdf_info->prev_pos.jump[i].zoom = 0;
					pdf_info->prev_pos.jump[i].saved = FALSE;
					}


				opened_pdf ++;

				if (opened_pdf > 0)
					switch_menu_entries(1);
			}
		}
		else
			return(FALSE);

		while (x_form_do (0L) != MU_TIMER);					/* wait the pdf window is open with toolbar and background */

		update_pdf_window (window);							/* and finaly display the page ! */

		return (TRUE);
	}

	Change_status (STATUS_WIN_CLOSE, 0, 0);					/* close the status window */
	return (FALSE);
}


	/* set the size of the toolbar in relation of the window size */
void adapt_pdf_window (short window)
{
	short w, h;
	WIND_LIST *wind;
	OBJECT *adr;

	wind = &windows[window];
	adr = wind->w_dial.d_addr;

	w = wind->w_work_wind.g_w;
	adr[HTBAR_TB + 1].ob_width = adr[HTBAR_TB].ob_width = w;
	adr->ob_width = adr[IBAR_TB].ob_width = w + adr[VTBAR_TB].ob_width;
	h = wind->w_work_wind.g_h;
	adr[DTREE_TB].ob_height = h - adr[UP_TB].ob_height + 2;
	w = adr[VTBAR_TB].ob_width - adr[SEP_TB].ob_width;
	adr[DTREE_TB].ob_width = w - adr[UP_TB].ob_width + 1;
	adr[VBAR_TB].ob_height = h - adr[UP_TB].ob_height * 2 + 4;
	adr[SEP_TB].ob_height = h + 2;
	h += adr[VTBAR_TB + 1].ob_height;
	adr->ob_height = h + adr[IBAR_TB].ob_height;
	adr[VTBAR_TB].ob_height = h;
	h -= adr[LEFT_TB].ob_height - 3;
	adr[LEFT_TB].ob_y = adr[HBAR_TB].ob_y = adr[RIGHT_TB].ob_y = adr[DOWN_TB].ob_y = h;
}


void redraw_pdf_window (short window)
{
	short handle, x, y;
	WIND_LIST *wind;

	wind = &windows[window];
	handle = x_gem->handle;


	if (wind->w_iconify)
		{
		wind_get (wind->w_hand, WF_WORKXYWH, &adr_icons->ob_x, &adr_icons->ob_y, &adr_icons->ob_width, &adr_icons->ob_height);
		x = (adr_icons->ob_width - adr_icons[ICON_1].ob_width) >> 1;
		if (x < 0)
			x = 0;
		y = (adr_icons->ob_height - adr_icons[ICON_1].ob_height) >> 1;
		if (y < 0)
			y = 0;
		adr_icons[ICON_1].ob_x = x;
		adr_icons[ICON_1].ob_y = y;

		s_objc_draw (adr_icons, ROOT, MAX_DEPTH, wind->w_redraw_grect);
		}
	else
		{
		vswr_mode (handle, MD_REPLACE);
		vsf_perimeter (handle, 0);

			/* Display the background: */
		if (x_gem->extended_inquire[4] < 8)
		{
			vsf_interior (handle, FIS_PATTERN);
			vsf_style (handle, 1);
			vsf_color (handle, LBLACK);
		}
		else
		{
			vsf_interior (handle, FIS_SOLID);
			vsf_color (handle, 187);
		}
		vr_recfl (handle, wind->w_redraw_pxy);

			/* Display the page itself: */
		Display_page (wind);
		update_page_info();
	}
}


void close_pdf_window (short window)
{
	WIND_LIST *wind=NULL;
	WIND_INFO *wind_info=NULL;

	wind = &windows[window];
	wind_info = wind->w_user1;

	FreePDF (wind_info->pdf_info);

	clear_all_pdf_objects (wind);

	if (wind_info->pdf_info->file_info->handle > 0)
		close (wind_info->pdf_info->file_info->handle);

	free (wind_info);

	opened_pdf --;

	if (opened_pdf <= 0)
		switch_menu_entries(0);
	Delete_window_from_popup(window);
}



	/* This function is called to redraw the page, */
	/* when page is changed/zoomed */
void update_pdf_window (short window)
{
	static unsigned long prev_page=-1;
	static WIND_LIST *prev_wind;
	int dummy_x, dummy_y, dummy_w, dummy_h;
	char buf[256]={0}, i, *text=NULL;
	WIND_LIST *wind;
	struct PDF_Info *pdf_info;

	wind = &windows[window];
	pdf_info = ((WIND_INFO *)(wind->w_user1))->pdf_info;


	/* *****************************************	*/
	/* Add the next position to the history tree	*/

	if(add2history==TRUE)
		{
		if(pdf_info->prev_pos.act_pos>=19)			/* Do we have still enough place to store	?*/
			{																			/* No	*/
			for(i=0; i<20; i++)
				{
				memcpy(&(pdf_info->prev_pos.jump[i]), &(pdf_info->prev_pos.jump[i+1]), sizeof(struct _jump_));			/* We have to shift the history	a bit	*/
				}
			pdf_info->prev_pos.act_pos = 19;
			}
		i = (pdf_info->prev_pos.act_pos)++;

		pdf_info->prev_pos.jump[i].page_no = (short)pdf_info->page_no;
		pdf_info->prev_pos.jump[i].pos_x = wind->w_work_wind.g_x;
		pdf_info->prev_pos.jump[i].pos_y = wind->w_work_wind.g_y;
		pdf_info->prev_pos.jump[i].zoom = (short)pdf_info->zoom;
		pdf_info->prev_pos.jump[i].saved = TRUE;

		if(pdf_info->prev_pos.jump[i+1].saved == TRUE && pdf_info->prev_pos.act_pos<19)
			wind->w_dial.d_addr[FORWARD_TB].ob_state &= ~DISABLED;
		else
			wind->w_dial.d_addr[FORWARD_TB].ob_state |= DISABLED;

		if(pdf_info->prev_pos.act_pos<=1)
			wind->w_dial.d_addr[REAR_TB].ob_state |= DISABLED;
		else
			wind->w_dial.d_addr[REAR_TB].ob_state &= ~DISABLED;

		x_redraw_wind (x_gem->event_wind, DRAW_AES, FORWARD_TB, &x_gem->desk_size);
		x_redraw_wind (x_gem->event_wind, DRAW_AES, REAR_TB, &x_gem->desk_size);
		}

	text = x_get_ob_text (wind->w_dial.d_addr, HISTORY_POS);
	if(text!=NULL)
		{
		if(add2history==TRUE)
			sprintf(text, "%d/20", pdf_info->prev_pos.act_pos);
		else
			sprintf(text, "%d/20", pdf_info->prev_pos.act_pos+1);
		x_redraw_wind (window, DRAW_AES, HISTORY_BACK, &x_gem->desk_size);
		}
	
	/* *****************************************	*/


	PageNumber (pdf_info, (short)pdf_info->page_no, &buf[0]);
	strcat (buf, " / ");
	PageNumber (pdf_info, pdf_info->pages->max_to_load, &buf[10]);
	strcat (buf, &buf[10]);
	x_set_ob_text (wind->w_dial.d_addr, PAGE_TB, buf);
	x_redraw_wind (window, DRAW_AES, PAGE_TB-1, &x_gem->desk_size);

	if (pdf_info->pages)
	{
		if (pdf_info->page_no == pdf_info->pages->max_to_load)
		{
			wind->w_dial.d_addr[LAST_TB].ob_state |= DISABLED;
			wind->w_dial.d_addr[NEXT_TB].ob_state |= DISABLED;
			x_redraw_wind (x_gem->event_wind, DRAW_AES, LAST_TB, &x_gem->desk_size);
			x_redraw_wind (x_gem->event_wind, DRAW_AES, NEXT_TB, &x_gem->desk_size);
		}
		else if (pdf_info->page_no != pdf_info->pages->max_to_load && (wind->w_dial.d_addr[LAST_TB].ob_state & DISABLED))
		{
			wind->w_dial.d_addr[LAST_TB].ob_state -= DISABLED;
			wind->w_dial.d_addr[NEXT_TB].ob_state -= DISABLED;
			x_redraw_wind (x_gem->event_wind, DRAW_AES, LAST_TB, &x_gem->desk_size);
			x_redraw_wind (x_gem->event_wind, DRAW_AES, NEXT_TB, &x_gem->desk_size);
		}
		if (pdf_info->page_no == 1)
		{
			wind->w_dial.d_addr[FIRST_TB].ob_state |= DISABLED;
			wind->w_dial.d_addr[PREV_TB].ob_state |= DISABLED;
			x_redraw_wind (x_gem->event_wind, DRAW_AES, FIRST_TB, &x_gem->desk_size);
			x_redraw_wind (x_gem->event_wind, DRAW_AES, PREV_TB, &x_gem->desk_size);
		}
		else if (pdf_info->page_no > 1 && (wind->w_dial.d_addr[FIRST_TB].ob_state & DISABLED))
		{
			wind->w_dial.d_addr[FIRST_TB].ob_state -= DISABLED;
			wind->w_dial.d_addr[PREV_TB].ob_state -= DISABLED;
			x_redraw_wind (x_gem->event_wind, DRAW_AES, FIRST_TB, &x_gem->desk_size);
			x_redraw_wind (x_gem->event_wind, DRAW_AES, PREV_TB, &x_gem->desk_size);
		}
	}

	if(prev_page!=pdf_info->page_no || prev_wind!=wind)
		Init_display_page (window, pdf_info);						/* render the page in a vdi-friendly structure */
	else
		Change_scale(window, pdf_info, &pdf_info->page_w, &pdf_info->page_h, &pdf_info->off_x, &pdf_info->off_y, &dummy_x, &dummy_y, &dummy_w, &dummy_h, wind);

	prev_page = pdf_info->page_no;
	prev_wind = wind;

	x_redraw_wind (window, DRAW_VDI, ROOT, &wind->w_work_wind);
	update_page_info();
}