#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"cont_pat.h"
#include	"windinfo.h"
#include	"page_con.h"


extern short wh_status;
extern WIND_LIST windows[];
extern X_GEM_INFO *x_gem;

extern struct _stream_command
	{
	char *name;
	int calls;
	int pos;
	char type;
	}stream_command[];


extern OBJECT *adr_menu, *adr_page_info, *adr_popup_page_info, *adr_icons, *adr_strings;
extern struct opt options;
int window_page_info_handle=-2;
void close_page_info(int);
void redraw_page_info_icon(int);

void do_options_popup(int window, int popup_type, OBJECT *adr_popup, int max_value, int *value, int output_text, int output_cycle);


static int how_many=0, slider_pos=0, what_to_show=1, how_much=0;			/* 1 - font, 2 - pictures, 3 - annotations, 4 - general	*/
static struct PDF_Info *pdf_info;

#define FONT_INFO				1
#define PICTURE_INFO		2
#define OBJECT_INFO			3
#define ANNOTATION_INFO	4
#define GENERAL_INFO		5


void update_page_info(void)
	{
	OBJECT *adr=NULL;
	WIND_LIST *wind=NULL;
	int i=0;
	short names[]={	PAGE_INFO_NAME1, PAGE_INFO_NAME2, PAGE_INFO_NAME3, PAGE_INFO_NAME4, PAGE_INFO_NAME5, PAGE_INFO_NAME6,
									PAGE_INFO_NAME7, PAGE_INFO_NAME8, PAGE_INFO_NAME9, PAGE_INFO_NAME10, PAGE_INFO_NAME11, PAGE_INFO_NAME12, -1};
	short types[]={	PAGE_INFO_TYPE1, PAGE_INFO_TYPE2, PAGE_INFO_TYPE3, PAGE_INFO_TYPE4, PAGE_INFO_TYPE5, PAGE_INFO_TYPE6,
									PAGE_INFO_TYPE7, PAGE_INFO_TYPE8, PAGE_INFO_TYPE9, PAGE_INFO_TYPE10, PAGE_INFO_TYPE11, PAGE_INFO_TYPE12, -1};
	short width[]={	PAGE_INFO_W1, PAGE_INFO_W2, PAGE_INFO_W3, PAGE_INFO_W4, PAGE_INFO_W5, PAGE_INFO_W6,
									PAGE_INFO_W7, PAGE_INFO_W8, PAGE_INFO_W9, PAGE_INFO_W10, PAGE_INFO_W11, PAGE_INFO_W12, -1};
	short height[]={	PAGE_INFO_H1, PAGE_INFO_H2, PAGE_INFO_H3, PAGE_INFO_H4, PAGE_INFO_H5, PAGE_INFO_H6,
										PAGE_INFO_H7, PAGE_INFO_H8, PAGE_INFO_H9, PAGE_INFO_H10, PAGE_INFO_H11, PAGE_INFO_H12, -1};
	short colors[]={	PAGE_INFO_C1, PAGE_INFO_C2, PAGE_INFO_C3, PAGE_INFO_C4, PAGE_INFO_C5, PAGE_INFO_C6,
										PAGE_INFO_C7, PAGE_INFO_C8, PAGE_INFO_C9, PAGE_INFO_C10, PAGE_INFO_C11, PAGE_INFO_C12, -1};

	if(window_page_info_handle==-2)
		return;

	wind = &x_gem->wind[window_page_info_handle];
	adr = wind->w_dial.d_addr;

	if(window_page_info_handle<0 || adr==NULL)
		adr = adr_page_info;

	if(adr==NULL)
		return;


	switch(what_to_show)
		{
		case FONT_INFO:				/* Font info					*/
			sprintf(x_get_ob_text(adr, PAGE_INFO_NAME_T), "~11Name  ");
			if(how_much==0)
				{
				sprintf(x_get_ob_text(adr, PAGE_INFO_TYPE_T),	"~11Type  ");
				sprintf(x_get_ob_text(adr, PAGE_INFO_W_T),			"~11ID    ");
				sprintf(x_get_ob_text(adr, PAGE_INFO_H_T),			"~11Effect");
				sprintf(x_get_ob_text(adr, PAGE_INFO_C_T),			"~11Angle ");
				}
			else
				{
				x_set_ob_text(adr, PAGE_INFO_TYPE_T,	"~11Encode");
				x_set_ob_text(adr, PAGE_INFO_W_T,			"~11Base  ");
				x_set_ob_text(adr, PAGE_INFO_H_T,			"~11PSName");
				x_set_ob_text(adr, PAGE_INFO_C_T,			"~11      ");
				}
			break;
		case PICTURE_INFO:				/* Pictures info			*/
			x_set_ob_text(adr, PAGE_INFO_NAME_T,	"~11Name  ");
			x_set_ob_text(adr, PAGE_INFO_TYPE_T,	"~11Type  ");
			x_set_ob_text(adr, PAGE_INFO_W_T,			"~11Width ");
			x_set_ob_text(adr, PAGE_INFO_H_T,			"~11Height");
			x_set_ob_text(adr, PAGE_INFO_C_T,			"~11Colors");
			break;
		case OBJECT_INFO:					/* Objects info (objects on the page)	*/
			x_set_ob_text(adr, PAGE_INFO_NAME_T,	"~11Name  ");
			x_set_ob_text(adr, PAGE_INFO_TYPE_T,	"~11Calls ");
			x_set_ob_text(adr, PAGE_INFO_W_T,			"~11Bar   ");
			x_set_ob_text(adr, PAGE_INFO_H_T,			"~11[%]   ");
			x_set_ob_text(adr, PAGE_INFO_C_T,			"~11      ");
			break;
		case ANNOTATION_INFO:				/* Annotations info		*/
			x_set_ob_text(adr, PAGE_INFO_NAME_T,	"~11Dupe  ");
			x_set_ob_text(adr, PAGE_INFO_TYPE_T,	"~11Dupe  ");
			x_set_ob_text(adr, PAGE_INFO_W_T,			"~11Dupe  ");
			x_set_ob_text(adr, PAGE_INFO_H_T,			"~11Dupe  ");
			x_set_ob_text(adr, PAGE_INFO_C_T,			"~11Dupe  ");
			break;
		case GENERAL_INFO:				/* General info				*/
			x_set_ob_text(adr, PAGE_INFO_NAME_T,	"~11Jsaiu ");
			x_set_ob_text(adr, PAGE_INFO_TYPE_T,	"~11Jsaiu ");
			x_set_ob_text(adr, PAGE_INFO_W_T,			"~11Jsaiu ");
			x_set_ob_text(adr, PAGE_INFO_H_T,			"~11Jsaiu ");
			x_set_ob_text(adr, PAGE_INFO_C_T,			"~11Jsaiu ");
			break;
		}

	for(i=0; names[i]!=-1; i++)
		{
		adr[names[i]].ob_flags &= ~SELECTABLE;
		adr[names[i]].ob_flags &= ~EXIT;
		strset(x_get_ob_text(adr, names[i]), ' ');
		strset(x_get_ob_text(adr, types[i]), ' ');
		strset(x_get_ob_text(adr, width[i]), ' ');
		strset(x_get_ob_text(adr, height[i]), ' ');
		strset(x_get_ob_text(adr, colors[i]), ' ');
		}

	switch(what_to_show)
		{
		case FONT_INFO:				/* Font info					*/
			{
			struct page_contents *cont=NULL;
			struct fonts *fonts=NULL;
			char effect[6]="     ";
			int j=0;

			cont = (struct page_contents*)pdf_info->pages_contents[0].adress;
			if(cont==NULL)
				break;
			fonts = cont->resource->fonts;
			if(fonts==NULL)
				break;

			how_many = fonts->loaded_fonts;
			if(how_many==1)
				sprintf(x_get_ob_text(adr, PAGE_INFOHOWMANY), "1 font");
			else
				sprintf(x_get_ob_text(adr, PAGE_INFOHOWMANY), "%d fonts", how_many);
			if(window_page_info_handle>0)
				x_objc_draw (window_page_info_handle, adr, PAGE_INFOHOWBACK, MAX_DEPTH, &x_gem->desk_size);

			for(i=0; names[i]!=-1, strlen(fonts[i].name)>0; i++)
				{
				adr[names[i]].ob_flags |= SELECTABLE;
				adr[names[i]].ob_flags |= EXIT;
				
				x_set_ob_text(adr, names[i], fonts[slider_pos+i].name);

				if(how_much==0)
					{
					char *font_types[]={"TTF   ", "Type 1", "Type 2.", "Type 3"};

					x_set_ob_text(adr, types[i], font_types[fonts[i].type]);

					ltoa(fonts[slider_pos+i].TT_id, x_get_ob_text(adr, width[i]), 10);
					sprintf(x_get_ob_text(adr, colors[i]), "%d", fonts[slider_pos+i].italic_angle);

					if(fonts[slider_pos+i].effect&MF_BOLD)
						effect[j++]='B';
					if(fonts[slider_pos+i].effect&MF_LIGHT)
						effect[j++]='L';
					if(fonts[slider_pos+i].effect&MF_ITALIC)
						effect[j++]='I';
					if(fonts[slider_pos+i].effect&MF_UNDERLINE)
						effect[j++]='U';
					if(fonts[slider_pos+i].effect&MF_SHADOW)
						effect[j++]='S';
					x_set_ob_text(adr, height[i], effect);
					}
				else
					{
					char *encoding_types[]={"Differ", "Stand ", "MacRom", "WinAns", "PDFDoc", "MaxExp", "ISOLat", "Symbol", "Dingba"};
					extern char *base_font_command[];

					x_set_ob_text(adr, types[i], encoding_types[fonts[i].encoding.type]);

					sprintf(x_get_ob_text(adr, fonts[slider_pos+i].TT_id), "%6s", base_font_command[fonts[i].base_font]);
					if(fonts[i].descriptor!=NULL)
						sprintf(x_get_ob_text(adr, fonts[slider_pos+i].TT_id), "%6s", fonts[i].descriptor->FontName);
					}
				}
			break;
			}


		case OBJECT_INFO:					/* Objects info (objects on the page)	*/
			{
			int j=0, max=0, proc=0;
			char *bars[]={"OOOOO", "OOOOo", "OOOO ", "OOOo ", "OOO  ", "OOo  ", "OO   ", "Oo   ", "O    ", "o    ", "     "};
									/*	100%		90%				80%			70%				60%			50%				40%			30%				20%			10%				0%			*/

			for(i=0, how_many=0; stream_command[i].name!=NULL; i++, how_many++)
				{
				if(stream_command[i].calls>max)
					max = stream_command[i].calls;
				}

			for(i=slider_pos; stream_command[i].name!=NULL && names[j]!=-1; i++, j++)
				{
				x_set_ob_text(adr, names[j], stream_command[i].name);
				sprintf(x_get_ob_text(adr, types[j]), "%-7d", stream_command[i].calls);
				proc = (100*stream_command[i].calls)/max;
				sprintf(x_get_ob_text(adr, height[j]), "%4d%%", proc);
				sprintf(x_get_ob_text(adr, width[j]), "%5s", bars[10-proc/10]);
				}
			for(i=0, how_many=0; stream_command[i].name!=NULL; i++, how_many++);
			}
			break;

		case PICTURE_INFO:				/* Pictures info			*/
			{
			struct page_contents *cont=NULL;
			struct picture *pictures=NULL;

			cont = (struct page_contents*)pdf_info->pages_contents[0].adress;
			if(cont==NULL)
				{
				x_set_ob_text(adr, PAGE_INFOHOWMANY, "no pictures");
				if(window_page_info_handle>0)
					x_objc_draw (window_page_info_handle, adr, PAGE_INFOHOWBACK, MAX_DEPTH, &x_gem->desk_size);
				break;
				}
			pictures = cont->resource->pictures;
			if(pictures==NULL)
				{
				x_set_ob_text(adr, PAGE_INFOHOWMANY, "no pictures");
				if(window_page_info_handle>0)
					x_objc_draw (window_page_info_handle, adr, PAGE_INFOHOWBACK, MAX_DEPTH, &x_gem->desk_size);
				break;
				}

			how_many = pictures->loaded;
			if(how_many==1)
				sprintf(x_get_ob_text(adr, PAGE_INFOHOWMANY), "1 picture");
			else
				sprintf(x_get_ob_text(adr, PAGE_INFOHOWMANY), "%d pictures", pictures->loaded);
			if(window_page_info_handle>0)
				x_objc_draw (window_page_info_handle, adr, PAGE_INFOHOWBACK, MAX_DEPTH, &x_gem->desk_size);

			for(i=0; names[i]!=-1, strlen(pictures[slider_pos+i].name)>0, i<how_many; i++)
				{
				x_set_ob_text(adr, names[i], pictures[slider_pos+i].name);
				ltoa(pictures[slider_pos+i].width, x_get_ob_text(adr, width[i]), 10);
				ltoa(pictures[slider_pos+i].height, x_get_ob_text(adr, height[i]), 10);
				itoa(pictures[slider_pos+i].BitsPerComponent, x_get_ob_text(adr, colors[i]), 10);
				}
			break;
			}

		case ANNOTATION_INFO:				/* Annotations info		*/
			{
			for(i=0; names[i]!=-1; i++)
				{
				x_set_ob_text(adr, names[i], "Function    ");
				x_set_ob_text(adr, types[i], "not    ");
				x_set_ob_text(adr, width[i], "avail");
				x_set_ob_text(adr, height[i], "able ");
				}
			break;
			}

		case GENERAL_INFO:				/* General info				*/
			for(i=0; names[i]!=-1; i++)
				{
				x_set_ob_text(adr, names[i], "Function    ");
				x_set_ob_text(adr, types[i], "not    ");
				x_set_ob_text(adr, width[i], "avail");
				x_set_ob_text(adr, height[i], "able ");
				}
			break;
		}

	if(window_page_info_handle==-1 || window_page_info_handle>0)
		x_init_slider (adr, PAGE_INFO_UP, PAGE_INFO_DOWN, PAGE_INFO_BAR, PAGE_INFOBARBACK, 1, 12, how_many, slider_pos, 0);

	if(window_page_info_handle>0)
		x_objc_draw (window_page_info_handle, adr, PAGE_INFO_BACK1, MAX_DEPTH, &x_gem->desk_size);
/*		s_objc_draw (adr, PAGE_INFO_BACK1, MAX_DEPTH, &x_gem->desk_size);	*/
	}



void open_page_info(void)
	{
	WIND_LIST *wind=NULL;
	WIND_INFO *wind_info=NULL;
	static ICON_LIST icw = {0, 8, 8, 32, 32, IL_USER, 0L, 0L};	/* for iconify */

	if(window_page_info_handle==-2)
		{
		window_page_info_handle = -1;
		slider_pos = 0;
		}
	else
		{
		wind_set (x_gem->wind[window_page_info_handle].w_hand, WF_TOP, 0, 0, 0, 0);
		return;
		}

	how_much = 0;

	wind = &x_gem->wind[x_gem->event_wind];
	wind_info = wind->w_user1;
	pdf_info = wind_info->pdf_info;

	x_set_ob_text(adr_page_info, PAGE_INFO_POPTE, x_get_ob_text(adr_popup_page_info, what_to_show));

	if (window_page_info_handle < 0)
		window_page_info_handle = x_open_wind (-1, -1, adr_page_info->ob_width - 1, adr_page_info->ob_height - 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, CLOSER|NAME|MOVER, "Page info", "", 0L, adr_page_info, &icw, 0L, 0L, (FNCP1)redraw_page_info_icon, (FNCP1)close_page_info, 0L);

	wind = &x_gem->wind[window_page_info_handle];
	if(wind->w_user1!=NULL)
		{
		wind_info = wind->w_user1;
		wind_info->pdf_info = NULL;
		}

	menu_tnormal (adr_menu, x_gem->event_buffer[3], 1);
	update_page_info();
	}




void handle_page_info(int window, int obj)
	{
	OBJECT *adr=NULL;
	WIND_LIST *wind=NULL;

	wind = &x_gem->wind[window];
	adr = wind->w_dial.d_addr;

	switch(obj)
		{
		case PAGE_INFO_POPTE:
			do_options_popup(window_page_info_handle, 0, adr_popup_page_info, 3, &what_to_show, PAGE_INFO_POPTE, PAGE_INFO_POPCY);
			if(what_to_show!=0)
				{
				adr[PAGE_INFO_MORE].ob_state &= ~DISABLED;
				adr[PAGE_INFO_MORE].ob_flags &= ~SELECTABLE;
				}
			else
				{
				adr[PAGE_INFO_MORE].ob_state |= DISABLED;
				adr[PAGE_INFO_MORE].ob_flags |= SELECTABLE;
				}
			update_page_info();
			break;

		case PAGE_INFO_POPCY:
			do_options_popup(window_page_info_handle, 1, adr_popup_page_info, 3, &what_to_show, PAGE_INFO_POPTE, PAGE_INFO_POPCY);
			if(what_to_show!=0)
				{
				adr[PAGE_INFO_MORE].ob_state &= ~DISABLED;
				adr[PAGE_INFO_MORE].ob_flags &= ~SELECTABLE;
				}
			else
				{
				adr[PAGE_INFO_MORE].ob_state |= DISABLED;
				adr[PAGE_INFO_MORE].ob_flags |= SELECTABLE;
				}
			update_page_info();
			break;

		case PAGE_INFO_OK:
			x_close_wind(window_page_info_handle);
			break;
		case PAGE_INFO_MORE:
			if(what_to_show==FONT_INFO && how_much==0)
				{
				x_set_ob_text(adr, PAGE_INFO_MORE, "?");
				how_much = 1;
				update_page_info();
				}
			else if(what_to_show==FONT_INFO && how_much==1)
				{
				x_set_ob_text(adr, PAGE_INFO_MORE, "?");
				how_much = 0;
				update_page_info();
				}
			else if(what_to_show==OBJECT_INFO)				/* Lat's save the page source as a unpacked file	*/
				{
				struct page_contents *page_content=NULL;
				char pdf_file_name[512]={0};
				int handle_out=0;

				if (x_file_select (1, STR (DI_OPEN), "*.pag", options.paths.default_pdf_dir, pdf_file_name))
					{
					if((handle_out=open(pdf_file_name, O_RDONLY))>0)
						{
						close(handle_out);
						if(x_gem_alert("[3][Do you want to|overwrite this file?][Yes|No]", 0L)==2)
							break;
						}
					handle_out = open(pdf_file_name, O_WRONLY|O_CREAT|O_TRUNC);
					if(handle_out)
						{
						page_content = pdf_info->pages_contents[0].adress;
						write(handle_out, page_content->content, page_content->content_len);
						close(handle_out);
						}
					}
				}
			break;
		case PAGE_INFO_DOWN:
		case PAGE_INFO_UP:
		case PAGE_INFO_BAR:
		case PAGE_INFOBARBACK:
			x_use_slider (adr, obj, PAGE_INFO_UP, PAGE_INFO_DOWN, PAGE_INFO_BAR, PAGE_INFOBARBACK, 1, 12, how_many, (short*)(&slider_pos), 0L, 0L);
			update_page_info();
			break;
		default:
			/* printf("*");	*/
			break;
		}
	}


void close_page_info(int window)
	{
	if(window == window_page_info_handle)
		{
		window_page_info_handle = -2;
		pdf_info = NULL;
		}
	}


void redraw_page_info_icon(int window)
	{
	int x, y;
	WIND_LIST *wind=NULL;

	wind = &x_gem->wind[window];

	if (wind->w_iconify)
		{
		wind_get (wind->w_hand, WF_WORKXYWH, &adr_icons->ob_x, &adr_icons->ob_y, &adr_icons->ob_width, &adr_icons->ob_height);
		x = (adr_icons->ob_width - adr_icons[ICON_1].ob_width) >> 1;
		if (x < 0)
			x = 0;
		y = (adr_icons->ob_height - adr_icons[ICON_1].ob_height) >> 1;
		if (y < 0)
			y = 0;
		adr_icons[ICON_1].ob_x = x;
		adr_icons[ICON_1].ob_y = y;

		s_objc_draw (adr_icons, ROOT, MAX_DEPTH, wind->w_redraw_grect);
		}
	}