#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"typespdf.h"
#include	"mp_const.h"
#include	"files.h"

#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mypdf.h"

char *read_command(int );
int read_object_no(int );
char *read_prev_line(int );
long find_object_number(int , unsigned int );
BOOLEAN Check_1st_line (struct PDF_Info *PDF_info);
BOOLEAN Check_last_line(struct PDF_Info *PDF_Info);
char *Read_prev_line(struct files_pdf *);
void Add_entry2steps(int value);

extern struct opt options;



BOOLEAN Check_if_pdf(char *name, struct PDF_Info *pdf_info)
	{
	int handle=-1;
	unsigned long file_size=0;
	char *line=NULL;

	if((handle=open(name, O_RDONLY))>0)				/* Is it a file?	*/
		{
		Change_status(STATUS_PDF_CHECKING_IF_PDF, 0, 0);
		Change_status(STATUS_BAR1_UPDATE, 0, 9);
		Add_entry2steps(STEPS_CHECKING);
		Add_entry2steps(STEPS_LOADING);

		pdf_info->file_info = calloc (1, sizeof (struct files_pdf) + 32);
		pdf_info->file_info->name = calloc (1, strlen (name) + 16);

		strcpy(pdf_info->file_info->name, name);

		file_size = Fseek(0, handle, 2);
		Fseek(0, handle, 0);

		if(file_size<options.max_mem)			/* Is the file size < 9MB ?	*/
			{
			pdf_info->file_info->buffer = calloc (1, file_size + 20);
			if(pdf_info->file_info->buffer!=NULL)
				{
				Change_status (STATUS_BAR1_UPDATE, STATUS_PDF_LOADING_FILE, 0);
				pdf_info->file_info->buff_size = file_size;							/* Size of the buffer				*/
				read(handle, pdf_info->file_info->buffer, file_size);		/* Loads the file to memory	*/
				close(handle);																					/* Close the file						*/
				Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_LOADING_FILE, 0);
				pdf_info->file_info->handle = -1;
				}
			else
				{
				x_gem_alert("[3][Not enough memory....][ hmm ]", 0L);
				return(FALSE);
				}
			}
		else
			{
			pdf_info->file_info->buff_size = file_size;							/* Size of the buffer				*/
			pdf_info->file_info->handle = handle;
			}

		Change_status (STATUS_BAR1_UPDATE, STATUS_PDF_CHECKING_IF_PDF, 0);

		if(Check_1st_line(pdf_info)==FALSE)
			{
			x_gem_alert("[3][Sorry, this is not an PDF Document][hmmm]", 0L);
			return(FALSE);
			}

		if(Check_last_line(pdf_info)==TRUE)
			{
			Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_CHECKING_IF_PDF, 0);
			return(TRUE);
			}
		else
			{
			handle = 0;
			line = Read_prev_line(pdf_info->file_info);
			while(strcmp(line, "%PDF-")!=0 && handle<1000)
				{
				if(strcmp(line, "%%EOF")==0)
					return(TRUE);
				pdf_info->file_info->actual_pos -= strlen(line);
				line = Read_prev_line(pdf_info->file_info);
				handle++;
				}
			}
		x_gem_alert("[3][Sorry, this is not an PDF Document][hmmm]", 0L);
		return(FALSE);
		}
	else
		{
		char *buf=calloc(1, 256);
		sprintf(buf, "[3][%s|is not a real file!|%d][Hmm]", name, handle);
		x_gem_alert(buf, 0L);
		free(buf);
		}
	return(FALSE);
	}